//         Install Scripts as plug-in , TEMPLATE
//                         by
//  B.Schaffer (FELMI/ZFE) & D. R. G. Mitchell (ANSTO Materials)
//
//   Acknowledgements: Werner Grogger (FELMI/ZFE)
//                     Vincent Hou (Micron Tech.)
//
//   Template version: 1.0

// As written, this script will install five scripts called Script1.s, Script2.s  - Script5.s into a package
// called My Package This creates a series of menu items in the Custom menu.

/******* Constants of the package ********/
/*    Please modify this to your needs     */
/*********************************************/

string PackageName      = "My_Package"	// This is the filename of the plug-in
number PackageLevel   = 0			// This defines the loading priority of
					// this plug-in compared to others. 
string MenuName            = "Custom"		// This is the default name of the menu
number PackageVersion = 20071121		// This number gives the file version of 
					// the plug-in. It is convenient to use 
					// date related numbers of type YYYYMMDD.
string folder				// The path to the script containing folder
					// including the last backslash (\)
number lineCount      = 0			// Variable to count number of installed "lines" in the menu.

// Please note that these constants are declared as global variables which 
// are therefore also valid within the functions below!


/********* Auxillary Functions  **********/
/*       No modification necessary        */
/*******************************************/
number AddS2P(string ScriptName, string CommandName, string Menu, string SubMenu)
{
  // This function installs a script as a menu command
  result(" Installing <"+ScriptName+">\n\t")
  try 
   {
   AddScriptFileToPackage(folder+ScriptName,PackageName,PackageLevel,CommandName,Menu,SubMenu,0)
   }
  catch
   {
   beep()
   result(" => Error while installing as a menu command ("+Menu+"-"+SubMenu+"-"+CommandName+").\n")	
   return -1
   }
  result(" => Installed as a menu command ("+Menu+"-"+SubMenu+"-"+CommandName+").\n")	
  return 1
}


number AddLib2P(string ScriptName)
  {
  // This function installs a script as a library
  result(" Installing <"+ScriptName+">\n\t")
  try 
    {
    AddScriptFileToPackage(folder+ScriptName,PackageName,PackageLevel,ScriptName,"","",1)
    }
  catch
   {
   beep()
   result(" => Error while installing as a library.\n")	
   return -1
   }
  result(" => Installed as a library.\n")	
  return 1
}


number AddLine2P(string Menu, string SubMenu)
{
  // This function intalls a seperation line in a menu
  // Note, that it is necessary to install each line under a different 
  // "position" with regard to menu/submenu/command-name. That is the 
  // reason, why the line-count variable is needed.
  LineCount++
  result(" Installing a line\n\t")
  AddScriptToPackage("",PackageName,PackageLevel,"-"+menu+"."+LineCount, menu, submenu, 0)
  result(" => Installed.\n")
  return 1
}

/******* MAIN INSTALLATION SCRIPT ***/
/*    Please modify this to your needs       */
/***********************************************/

result("\n Installing files for plug-in <"+PackageName+">\n")

// First get the base-folder
folder = GetApplicationDirectory(2,0)
If (!GetDirectoryDialog("Please select base folder.",folder,folder)) exit(-1)

// Now install all your scripts. Modify this section manually to your needs.
// The lines shown assume that the scripts are in the base folder.
// They will install a menu called "Custom" (see global parameters) with the 
// following structure:
//    CUSTOM
//         + Command 1
//         + SubMenu 1
//		 + Command S1
//		 + ----------
//		 + Command S2
//         + Command 2
//         + Command 3
//
// Additionally, a script "MyLibrary.s" will be installed as a library.

AddLib2P("MyLibrary.s")
AddS2P("script1.s","Command 1",MenuName,"")
AddS2P("script2.s","Command S1",MenuName,"SubMenu 1")
AddLine2P(MenuName,"SubMenu 1")
AddS2P("script3.s","Command S2",MenuName,"SubMenu 1")
AddS2P("script4.s","Command 2",MenuName,"")
AddS2P("script5.s","Command 3",MenuName,"")
