
//         Install Scripts as plug-in , TEMPLATE
//                         by
//  B.Schaffer (FELMI/ZFE) & D.R. G. Mitchell (ANSTO Materials)
//
//   Acknowledgements: Werner Grogger (FELMI/ZFE)
//                     Vincent Hou (Micron Tech.)
//
//   Template version: 2.0


/******* Constants of the package ********/
/*    Please modify this to your needs     */
/*********************************************/

string PackageName      = "My_Package"	// This is the filename of the plug-in
number PackageLevel   = 0			// This defines the loading priority of
					// this plug-in compared to others. 
string MenuName            = "Custom"		// This is the default name of the menu
number PackageVersion = 20071121		// This number gives the file version of 
					// the plug-in. It is convenient to use 
					// date related numbers of type YYYYMMDD.
string folder				// The path to the script containing folder
					// including the last backslash (\)
number lineCount      = 0			// Variable to count number of installed "lines" in the menu.

// Please note that these constants are declared as global variables which 
// are therefore also valid within the functions below!


/********* Auxillary Functions  **********/
/*       No modification necessary        */
/*******************************************/
number AddS2P(string ScriptName, string CommandName, string Menu, string SubMenu)
{
  // This function installs a script as a menu command
  result(" Installing <"+ScriptName+">\n\t")
  try 
   {
   AddScriptFileToPackage(folder+ScriptName,PackageName,PackageLevel,CommandName,Menu,SubMenu,0)
   }
  catch
   {
   beep()
   result(" => Error while installing as a menu command ("+Menu+"-"+SubMenu+"-"+CommandName+").\n")	
   return -1
   }
  result(" => Installed as a menu command ("+Menu+"-"+SubMenu+"-"+CommandName+").\n")	
  return 1
}


number AddLib2P(string ScriptName)
  {
  // This function installs a script as a library
  result(" Installing <"+ScriptName+">\n\t")
  try 
    {
    AddScriptFileToPackage(folder+ScriptName,PackageName,PackageLevel,ScriptName,"","",1)
    }
  catch
   {
   beep()
   result(" => Error while installing as a library.\n")	
   return -1
   }
  result(" => Installed as a library.\n")	
  return 1
}


number AddLine2P(string Menu, string SubMenu)
{
  // This function intalls a seperation line in a menu
  // Note, that it is necessary to install each line under a different 
  // "position" with regard to menu/submenu/command-name. That is the 
  // reason, why the line-count variable is needed.
  LineCount++
  result(" Installing a line\n\t")
  AddScriptToPackage("",PackageName,PackageLevel,"-"+menu+"."+LineCount, menu, submenu, 0)
  result(" => Installed.\n")
  return 1
}

/******* MAIN INSTALLATION SCRIPT ***/
/*    Please modify this to your needs       */
/***********************************************/
object	DLG1			// Object for the dialogues
documentWindow  DLGWindow	// DialogWindow
taggroup DLGtg,DLGitems		// Items for the dialogues
taggroup DropMenu,DropMenuItems	// DropMenu Items within the dialogues
number userlevel,language		// variables keeping the setting

result("\n Installing files for plug-in <"+PackageName+">\n")

// First get the base-folder
folder = GetApplicationDirectory(2,0)
If (!GetDirectoryDialog("Please select base folder.",folder,folder)) exit(-1)

// Build First Dialog (UserLevel)
DLGtg = DLGCreateDialog("Level",DLGitems)
DropMenu = DLGCreatePopup(DropMenuItems,1)
DropMenuItems.DLGAddPopupItemEntry("Novice user")
DropMenuItems.DLGAddPopupItemEntry("Experienced user")
DropMenuItems.DLGAddPopupItemEntry("Expert user")
DLGitems.DLGAddElement(DLGCreateLabel("Please select user level"))
DLGitems.DLGAddElement(DropMenu)

// Display First Dialog (UserLevel)
DLG1 = Alloc(UIframe).Init(DLGtg)
If (!DLG1.Pose()) exit(-1)

// Get the value (UserLevel)
DropMenu.DLGGetValue(userlevel)

// Build Sceond Dialog (Language)
DLGtg = DLGCreateDialog("Language",DLGitems)
DropMenu = DLGCreatePopup(DropMenuItems,1)
DropMenuItems.DLGAddPopupItemEntry("English")
DropMenuItems.DLGAddPopupItemEntry("German")
DLGitems.DLGAddElement(DLGCreateLabel("Please select command name language"))
DLGitems.DLGAddElement(DropMenu)

// Display Second Dialog (Language)
DLG1 = Alloc(UIframe).Init(DLGtg)
IF (!DLG1.Pose()) exit(-1)

// Get the value (Language)
DropMenu.DLGGetValue(language)

// Now install all your scripts. Modify this section manually to your needs.
AddLib2P("MyLibrary.s")
// The different "languages" lead to different installation trees
If (language==1)
	{
	If (UserLevel>0) AddS2P("script1.s","NOVICE Command",MenuName,"")
	If (UserLevel>1) AddS2P("script1.s","EXPERIENCED Command",MenuName,"")
	If (UserLevel>2) AddS2P("script1.s","EXPERT Command",MenuName,"")
	}
If (language==2)
	{
	If (UserLevel>0) AddS2P("script1.s","Anfnger",MenuName,"")
	If (UserLevel>1) AddS2P("script1.s","Benutzer",MenuName,"")
	If (UserLevel>2) AddS2P("script1.s","Experte",MenuName,"")
	}

